Gnomario = {};
Gnomario_Settings = Gnomario_Settings or {};


---- Storyboard ----
Gnomario.window = CreateFrame("Frame", nil, UIParent);
Gnomario.window:SetBackdrop({bgFile = "Interface/GLUES/loading",edgeFile = "Interface/GLUES/Common/TextPanel-Border",edgeSize = 16,insets = { left = 4, right = 4, top = 4, bottom = 4 }});
Gnomario.window:SetBackdropColor(1,1,1,0.4);
Gnomario.window:SetWidth(480)
Gnomario.window:SetHeight(320);
Gnomario.window:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
Gnomario.window:RegisterForDrag("LeftButton");
Gnomario.window:SetScript("OnDragStart",function()  Gnomario.window:StartMoving(); end);
Gnomario.window:SetScript("OnDragStop", function()  Gnomario.window:StopMovingOrSizing(); end);
Gnomario.window:SetMovable(true);
Gnomario.window:EnableMouse(true);
Gnomario.window:EnableMouseWheel(true);
Gnomario.window:Hide();
Gnomario.window.menuFrame = CreateFrame("Frame", "Gnomario.window_Menu", UIParent, "UIDropDownMenuTemplate")

-- close button
local close = CreateFrame("button", nil, Gnomario.window, "UIPanelCloseButton");
close:SetPoint("TOPRIGHT", Gnomario.window, "TOPRIGHT", 0, 0);
Gnomario.engine = Gnomario_Engine(Gnomario.window, GNOMARIO_GAME_DATA);
Gnomario.engine:SetSpeed(30); -- 1 = fastest, 100 = slooooooooooowest. somewhere between 15 and 60 would be sane.
Gnomario.engine:LoadWorld("level1");
local gnome = Gnomario.engine.world:Spawn_Creature('gnomario');
Gnomario.engine:SetProtagonist(gnome);
Gnomario.engine:Start();

_G.SLASH_GNOMARIO1 = '/gnomario';
_G.SLASH_GNOMARIO2 = '/mario';
SlashCmdList['GNOMARIO'] = function(chan) Gnomario.window:Show() PlaySoundFile([[Interface\AddOns\Gnomario\Sounds\coin.ogg]]); end;



---- Map editor ----
local libmg = LibStub("LibMouseGestures-1.0");
local recorder = libmg:New(Gnomario.window);
recorder.tex = recorder.drawLayer:CreateTexture("OVERLAY");
recorder.tex:SetSize(32,32);

local function maped_update(rec,a,b,c,d)
	local x, y = math.floor(((c-16)/32)+0.5)*32, 320 - math.floor((d/32)+0.5)*32
	rec.tex:SetPoint("BOTTOMLEFT", x, y);
end

local function maped_put(rec,a,b,c,d)
	local x, y = math.floor(((c-16)/32)+0.5)*32, 320 - (math.floor((d/32)+0.5)*32)
	local mob = Gnomario.engine.world:Spawn_Object(rec.mob.id);
	if not mob then mob = Gnomario.engine.world:Spawn_Creature(rec.mob.id); end
	if mob then
		mob.x = x;
		mob.y = y;
	end
end

local function maped_place(mob)
	if mob.tex then
		recorder.tex:SetTexture([[Interface\AddOns\Gnomario\Textures\]] .. mob.tex);
	end
	recorder:StartCapture({
	startButton        = "LeftButtonUp",
	nextButton        = "LeftButtonUp",
	cancelButton    = "RightButtonUp",
	updateFunc        = maped_update,
	cancelFunc        = maped_nil,
	nextFunc        = maped_put,
	tooltip            = {
		"Placing a " .. mob.id, -- tooltip title
		"Left click to place an object,",
		"Right click to stop placing"
	}
	});
	recorder.isRecording = true;
	recorder.mob = mob;

end

local y = 0;
for k,obj in pairs(Gnomario.engine.xml.environment) do
	if type(obj) == "table" and obj.args then
		local mob = {};
		mob.id = obj.args.id;
		mob.width = obj.args.width or 20;
		mob.height = obj.args.height or 20;
		mob.speed = tonumber(obj.args.speed) or 1;
		mob.health = tonumber(obj.args.health) or 1;
		if obj.args.hostile == "true" then mob.hostile = true; end
		mob.tex = obj.args.tex;
		local icon = CreateFrame("Frame", nil, Gnomario.window)
		local tex = icon:CreateTexture("ARTWORK");
		if mob.tex then tex:SetTexture([[Interface\AddOns\Gnomario\Textures\]] .. mob.tex) end
		tex:SetAllPoints(icon);
		icon:SetSize(32,32);
		icon:SetPoint("TOPLEFT", Gnomario.window, "TOPRIGHT", 10, y);
		icon:EnableMouse(true);
		icon:SetScript("OnMouseDown", function() maped_place(mob) end);
		y = y - 36;
	end
end
for k,obj in pairs(Gnomario.engine.xml.creatures) do
	if type(obj) == "table" and obj.args then
		local mob = {};
		mob.id = obj.args.id;
		mob.width = obj.args.width or 20;
		mob.height = obj.args.height or 20;
		mob.speed = tonumber(obj.args.speed) or 1;
		mob.health = tonumber(obj.args.health) or 1;
		if obj.args.hostile == "true" then mob.hostile = true; end
		mob.tex = obj.args.tex;
		local icon = CreateFrame("Frame", nil, Gnomario.window)
		local tex = icon:CreateTexture("ARTWORK");
		if mob.tex then tex:SetTexture([[Interface\AddOns\Gnomario\Textures\]] .. mob.tex) end
		tex:SetAllPoints(icon);
		icon:SetSize(32,32);
		icon:SetPoint("TOPLEFT", Gnomario.window, "TOPRIGHT", 10, y);
		icon:EnableMouse(true);
		icon:SetScript("OnMouseDown", function() maped_place(mob) end);
		y = y - 36;
	end
end

